Subject: [codec] AD Evaluation of draft-ietf-codec-oggopus-09

From: "Ben Campbell" <[email-masked]>
Date: Tue, 08 Dec 2015 19:43:21 -0600

(oops, sent from wrong address, and got bounced from a lot of lists. 
Apologies for the repeat. Please send replies to this address.)

Hi,

Here is my AD evaluation of draft-ietf-codec-oggopus-09. Codec 
encapsulation is not my strong suit, so I suspect many of my comments 
can be answered with "this is the way we normally do this thing". But 
I'd still like to discuss these before going to IETF last call.

Thanks!

Ben.

----------------

Substantive:
============

- section 2, last paragraph:

Is this paragraph necessary or useful? (And is it really impossible to 
create a non-compliant implementation that meets all the MUSTs?) I 
suggest removing it.

- section 3:
This section seems to use 2119 keywords to describe what I _think_ are 
existing Ogg requirements. If so, they should use descriptive text, 
unless they are in the form of attributed quotes.

- 3, last paragraph:
-- "implementations need to be prepared":
  maybe that should be a MUST or SHOULD?

-- "last page SHOULD NOT be a continued packet":
Why not MUST NOT? Can you describe reasons someone might reasonably 
violate this?

- 4.2, 2nd paragraph:
-- "samples which SHOULD be skipped": Why not MUST?  (also, 
s/which/that)
-- "SHOULD NOT be played": Is this redundant with SHOULD be skipped?

- 4.3: Should the reference to [vorbis-trim] be normative? Can the 
feature be implemented without understanding the referenced doc?

- 4.6: Should the reference to [seeking] be normative? Can the section 
be implemented without understanding it?

- 5.1, list entry 5: What is the unit for "Input Sample Rate"?

- 5.1, entry 6, sentence starting with "Virtually all players..."
Is this a normative statement, or a statement of fact? If the former, 
consider dropping “Virtually all”

- 5.1, entry 6, last paragraph:
-- "which MUST be omitted when the channel mapping family is 0": That 
seems redundant to the previous paragraph.
-- "Implementations SHOULD reject ID headers"
What does it mean, in context, to "reject" headers?

- 5.1.1.4: Why not MUST?

- 5.2, last two paragraph: Why are the two SHOULDs not MUSTs?

- 5.2.1, 2nd to last paragraph, last sentence:
I don’t think muxers assume things—what is the required concrete 
behavior?

- 5.2.1, last paragraph: Why is the SHOULD NOT not MUST NOT?

-6, first paragraph:
Why are the two SHOULDs not MUSTs? What does it mean to reject a packet?

-7: "reference implementation" could use a citation. Should 
[linear-predection] be normative? Can this be implemented without 
understanding that? If it does need to be normative, can you find a more 
stable reference?

- 9, first paragraph:
This seems to defer at least some security considerations to 4732. If 
so, this should be a normative reference. If, on the other hand, 4732 
just provides additional information that is not necessary to understand 
this section, then the wording should be adjusted.

- 13:
Is this needed? Are the IETF BCP 78 and 79 provisions incorrect for 
this?

Editorial
=========
- Section 1: Consider spelling out multiplexer (muxer) and demultiplexer 
(demuxer) on first mention.

- 3: Please expand TOC, SILK, and CELT on first mention.

- 5, steps 2 and 3:
These steps in combination seem to say “ decode at the highest 
available supported rate that the hardware can handle.” If so, the 
wording could be simplified.

- 7, 2nd paragraph:
I don’t think that’s literally true, you’ve defined 0, 1, and 255. 
The rest are reserved. (I guess one could argue the guidance to treat 
reserved values as 255 supports this statement, but I think that’s a 
stretch.

-5.1.1.2: Do you expect the reader to know what Vorbis channel order is? 
Also, please expand FLAC on first mention.

- 5.2.1, paragraph starting with " An Ogg Opus stream MUST NOT have more 
than one of each tag, and if present their values MUST be an integer"

each of these two new tags, or all tags? (I assume the former from the 
numeric values) Also, singular/plural mismatch in "their values MUST be 
an integer"

-10, last paragraph:

Updates, or extends? If the former, the draft needs an “Updates RFC 
5334” field in the initial heading.

---

From: "Timothy B. Terriberry" <[email-masked]>
Date: Fri, 11 Dec 2015 14:16:39 -0800

> I'd still like to discuss these before going to IETF last call.

Thank you for the very thorough review. Comments in-line below (as an 
individual).

> create a non-compliant implementation that meets all the MUSTs?) I

This was copied from RFC 5334. I don't think anyone has any particular 
attachment to it, so let's just remove it.

> unless they are in the form of attributed quotes.

I think I can attribute this mostly to paranoia over RFC 3533 being 
informational, and using descriptive text of its own for what should be 
normative requirements. E.g.,

"Ogg also allows but does not require secondary header packets after the 
bos page for logical bitstreams and these must also precede any data 
packets in any logical bitstream. These subsequent header packets are 
framed into an integral number of pages, which will not contain any data 
packets." (from RFC333)

vs.

"The second packet in the logical Ogg bitstream MUST contain the 
comment header ...  It MAY span multiple pages, beginning on the second 
page of the logical stream. However many pages it spans, the comment 
header packet MUST finish the page on which it completes." (from this draft)

Unless someone objects, though, I'll try to rewrite the latter without 
the 2119 keywords.

>   maybe that should be a MUST or SHOULD?

I think the intent was just to point out that someone might violate the 
preceding SHOULD. It's not clear what actionable thing we'd be saying 
they MUST do (it would depend on the particular implementation).

> Why not MUST NOT? Can you describe reasons someone might reasonably

The intent was to allow but discourage page-level editing of files 
(i.e., cutting and splicing files by copying complete pages without 
examining the packets on them). Even just saving a live stream that 
drops at some point, you might reasonably expect to just be able to copy 
the data you received to a file. A MUST here would mean you would have 
to parse the pages, identify the continued packets from the lacing 
values, remove the extraneous data from the last page if you found some, 
repack the page buffer, and recompute the page checksum. That's a lot 
more machinery, and people would likely just ignore the requirement in 
practice. See also the discussion at 
<https://www.ietf.org/mail-archive/web/codec/current/msg03145.html>.

> - 4.2, 2nd paragraph:
> -- "samples which SHOULD be skipped": Why not MUST?  (also, s/which/that)

Some specific applications might have a reason for looking at that data 
(for example, when you have multiple files that you know were produced 
by chopping up a single existing file without re-encoding). In practice 
we haven't needed anything stronger to convince people to implement this 
correctly (especially when we point them to 
<https://people.xiph.org/~greg/opus_testvectors/correctness_trimming_nobeeps.opus>).

> -- "SHOULD NOT be played": Is this redundant with SHOULD be skipped?

Yes. Deleted.

> feature be implemented without understanding the referenced doc?

The answer to the second question is "yes", which I think makes the 
answer to the first question "no". The reason this is here is to tell 
people familiar with how Vorbis works what mechanism they should use to 
achieve the same outcome in Opus. But if you're not familiar with 
Vorbis, then you can safely ignore the whole paragraph.

> be implemented without understanding it?

It is possible to implement seeking without knowing anything other than 
what is described in RFC 3533, but the linked documentation does help 
considerably.

I would argue that the section itself is not normative, in that you 
could implement seeking with some other method (for example, linearly 
scanning the whole file on open to build an index, possibly caching such 
indexes for files that are opened frequently: this would not be my 
recommended approach, but people have done it in practice). You could 
also choose to implement only approximate seeking by just guessing a 
file position and decoding from there (also done in practice by some 
players, and a common method for other formats like MP3). Or you could 
choose not to implement seeking at all.

> - 5.1, list entry 5: What is the unit for "Input Sample Rate"?

Hz. It was specified in Figure 1, but you're right, it should be in the 
text, too. Added the sentence, "This is the sample rate of the original 
input (before encoding), in Hz."

> consider dropping “Virtually all”

Dropped "virtually all".

> seems redundant to the previous paragraph.

Yes. Deleted the sentence in the previous paragraph.

> What does it mean, in context, to "reject" headers?

The same thing as rejecting a stream (i.e., don't try to play/decode 
it). Changed to say that instead.

> - 5.1.1.4: Why not MUST?

I think the idea was to allow assigning reserved values without 
explicitly updating this specification. Even though I expect we _would_ 
want to update this specification, given how long it's taken to get this 
draft published, I'm wary of adding more pressure to people not to 
deploy new mappings (because this RFC says they MUST not), even when it 
looks like they'll be relatively stable and interoperable. At least not 
for the sole reason that they haven't gotten an RFC number yet.

> - 5.2, last two paragraph: Why are the two SHOULDs not MUSTs?

For the first SHOULD, this is the same as above: some other 
specification may eventually define the format of the data here and how 
to modify it, and I didn't think we'd want to make people supporting 
that specification in violation of this specification. I'm also leaning 
towards keeping this one a SHOULD since a) the eventual format of this 
data may apply to all codecs which share the vorbiscomment style of 
metadata, and b) we would probably try to do this informally first to 
gain implementation experience, and only bring it to the IETF if there 
is sufficient interest. I didn't want to make updating this document a 
prerequisite for that. See also the discussion in this thread: 
<https://www.ietf.org/mail-archive/web/codec/current/msg03061.html> 
(skip to 
<https://www.ietf.org/mail-archive/web/codec/current/msg03107.html> for 
the resolution of the debate).

For the second SHOULD, it felt like the right strength for a judgment 
call like "excessive". I have no objection to changing it to MUST.

> I don’t think muxers assume things—what is the required concrete behavior?

I replaced this with "A muxer SHOULD place the gain it wants other tools 
to use by default into the 'output gain' field, and not the comment tag."

> - 5.2.1, last paragraph: Why is the SHOULD NOT not MUST NOT?

In some contexts, there may be no confusion with multiple normalization 
schemes. The language in this section was debated a good deal on the 
list (see threads 
<https://www.ietf.org/mail-archive/web/codec/current/msg02930.html>, 
<https://www.ietf.org/mail-archive/web/codec/current/msg03012.html>, and 
<https://www.ietf.org/mail-archive/web/codec/current/msg03053.html>). I 
believe everyone is satisfied with the current compromise, and would 
prefer not to change the strength of any normative statements in it to 
avoid re-igniting the debate.

> Why are the two SHOULDs not MUSTs? What does it mean to reject a packet?

For the first SHOULD, the fact that most decoders are likely to reject 
such packets is enough to discourage encoders from emitting them, and I 
was wary of imposing a MUST restriction when RFC 6716 chose not to do so.

For the second, this is the same as the previous comment about excessive 
allocations. I have no objection to changing this one, either.

"Reject a packet" is just shorthand for "treat them as if it was a 
malformed Opus packet with an invalid TOC sequence". I've added explicit 
text saying the latter.

> -7: "reference implementation" could use a citation. Should

Added a reference to RFC 6716.

> understanding that? If it does need to be normative, can you find a more

Linear prediction is something that would be understood by "a person 
having ordinary skill in the art" (to borrow a phrase). We just wanted 
to include a reference to help those who might not be DSP engineers but 
wanted to learn more.

> this section, then the wording should be adjusted.

Upgraded the reference to normative.

> - 13:
> Is this needed? Are the IETF BCP 78 and 79 provisions incorrect for this?

This text was specifically requested by the Debian project (and I 
support it personally). The same issue came up for RFC 6716 (for the 
same reasons). See the discussion at 
<https://www.ietf.org/mail-archive/web/codec/current/msg02845.html> and 
<https://www.ietf.org/mail-archive/web/ietf/current/msg73116.html>.

Reviewing those conversations, I do notice that the language of that 
section was changed after last call for RFC 6716, but the corresponding 
language in our source repository was not updated (because it was added 
to the document boilerplate manually by the RFC Editor, and not included 
in a separate section).

> (demuxer) on first mention.

Done.

> - 3: Please expand TOC, SILK, and CELT on first mention.

Doing this directly in the current text was a little bit awkward. I 
reworded it to

"...An implementation of this specification SHOULD treat any Opus packet 
whose duration is different from that of the first Opus packet in an Ogg 
packet as if it were a malformed Opus packet with an invalid Table Of 
Contents (TOC) sequence.

"The TOC sequence at the beginning of each Opus packet indicates the 
coding mode, audio bandwidth, channel count, duration (frame size), and 
number of frames per packet, as described in Section 3.1 of [RFC6716]. 
The coding mode is one of SILK, Hybrid, or Constrained Energy Lapped 
Transform (CELT). The combination of coding mode, audio bandwidth, and 
frame size is referred to as the configuration of an Opus packet."

I did not expand SILK because it is not an acronym.

> - 5, steps 2 and 3:
> These steps in combination seem to say “ decode at the highest available
> supported rate that the hardware can handle.” If so, the wording could
> be simplified.

It is a little bit more complicated. There are two rates here: one used 
for decoding, and one used for playback. The difference between steps 2 
and 3 is that in step 3, the hardware's highest available sample rate is 
not one of the rates supported by Opus decoding. For example, if the 
highest available sample rate the hardware can handle is 32 kHz, then 
this is not a "supported rate" (i.e., not supported by Opus decoding), 
so step 2 does not apply and step 3 does. Step 3 says to decode at the 
next highest "supported rate", which would be 48 kHz, and then resample 
to a rate the hardware can handle (in this case 32 kHz).

I don't think that's equivalent to your summary of the two steps.

> - 7, 2nd paragraph:
> I don’t think that’s literally true, you’ve defined 0, 1, and 255. The
> rest are reserved. (I guess one could argue the guidance to treat

Yes, this is really true for the currently defined mapping families. 
Changed to "Each currently specified value of this octet indicates..."

> Also, please expand FLAC on first mention.

It's a fairly common term among those who work with audio formats, but I 
added a "(see below)" for those who don't, since the table below it 
lists what that order is.

> numeric values) Also, singular/plural mismatch in "their values MUST be

"each of these tags" seems to resolve both issues.

> 5334” field in the initial heading.

Added the field.

A complete diff of the changes since -09 so far is attached (and, as 
always, can be found in the Opus git repository: 
<https://git.xiph.org/?p=opus.git>). I'll post again when I finish 
reviewing the changes for normative language for generic Ogg 
requirements and the extra copyright grant.
diff --git a/doc/draft-ietf-codec-oggopus.xml b/doc/draft-ietf-codec-oggopus.xml
index 124d488..b95e5bc 100644
--- a/doc/draft-ietf-codec-oggopus.xml
+++ b/doc/draft-ietf-codec-oggopus.xml
@@ -7,17 +7,18 @@
 <!ENTITY rfc5334 PUBLIC '' 'http://xml.resource.org/public/rfc/bibxml/reference.RFC.5334.xml'>
 <!ENTITY rfc6381 PUBLIC '' 'http://xml.resource.org/public/rfc/bibxml/reference.RFC.6381.xml'>
 <!ENTITY rfc6716 PUBLIC '' 'http://xml.resource.org/public/rfc/bibxml/reference.RFC.6716.xml'>
 <!ENTITY rfc6982 PUBLIC '' 'http://xml.resource.org/public/rfc/bibxml/reference.RFC.6982.xml'>
 <!ENTITY rfc7587 PUBLIC '' 'http://xml.resource.org/public/rfc/bibxml/reference.RFC.7587.xml'>
 ]>
 <?rfc toc="yes" symrefs="yes" ?>
 
-<rfc ipr="trust200902" category="std" docName="draft-ietf-codec-oggopus-09">
+<rfc ipr="trust200902" category="std" docName="draft-ietf-codec-oggopus-09"
+ updates="5334">
 
 <front>
 <title abbrev="Ogg Opus">Ogg Encapsulation for the Opus Audio Codec</title>
 <author initials="T.B." surname="Terriberry" fullname="Timothy B. Terriberry">
 <organization>Mozilla Corporation</organization>
 <address>
 <postal>
 <street>650 Castro Street</street>
@@ -100,18 +101,18 @@ Each page is associated with a particular logical stream and contains a capture
  pattern and checksum, flags to mark the beginning and end of the logical
  stream, and a 'granule position' that represents an absolute position in the
  stream, to aid seeking.
 A single page can contain up to 65,025 octets of packet data from up to 255
  different packets.
 Packets can be split arbitrarily across pages, and continued from one page to
  the next (allowing packets much larger than would fit on a single page).
 Each page contains 'lacing values' that indicate how the data is partitioned
- into packets, allowing a demuxer to recover the packet boundaries without
- examining the encoded data.
+ into packets, allowing a demultiplexer (demuxer) to recover the packet
+ boundaries without examining the encoded data.
 A packet is said to 'complete' on a page when the page contains the final
  lacing value corresponding to that packet.
 </t>
 <t>
 This encapsulation defines the contents of the packet data, including
  the necessary headers, the organization of those packets into a logical
  stream, and the interpretation of the codec-specific granule position field.
 It does not attempt to describe or specify the existing Ogg container format.
@@ -123,24 +124,16 @@ Readers unfamiliar with the basic concepts mentioned above are encouraged to
 
 <section anchor="terminology" title="Terminology">
 <t>
 The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD",
  "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this
  document are to be interpreted as described in <xref target="RFC2119"/>.
 </t>
 
-<t>
-Implementations that fail to satisfy one or more "MUST" requirements are
- considered non-compliant.
-Implementations that satisfy all "MUST" requirements, but fail to satisfy one
- or more "SHOULD" requirements are said to be "conditionally compliant".
-All other implementations are "unconditionally compliant".
-</t>
-
 </section>
 
 <section anchor="packet_organization" title="Packet Organization">
 <t>
 An Ogg Opus stream is organized as follows.
 </t>
 <t>
 There are two mandatory header packets.
@@ -175,25 +168,28 @@ The first (N&nbsp;-&nbsp;1) Opus packets, if any, are packed one after another
  into the Ogg packet, using the self-delimiting framing from Appendix&nbsp;B of
  <xref target="RFC6716"/>.
 The remaining Opus packet is packed at the end of the Ogg packet using the
  regular, undelimited framing from Section&nbsp;3 of <xref target="RFC6716"/>.
 All of the Opus packets in a single Ogg packet MUST be constrained to have the
  same duration.
 An implementation of this specification SHOULD treat any Opus packet whose
  duration is different from that of the first Opus packet in an Ogg packet as
- if it were a malformed Opus packet with an invalid TOC sequence.
+ if it were a malformed Opus packet with an invalid Table Of Contents (TOC)
+ sequence.
 </t>
 <t>
-The coding mode (SILK, Hybrid, or CELT), audio bandwidth, channel count,
- duration (frame size), and number of frames per packet, are indicated in the
- TOC (table of contents) sequence at the beginning of each Opus packet, as
- described in Section&nbsp;3.1 of&nbsp;<xref target="RFC6716"/>.
-The combination of mode, audio bandwidth, and frame size is referred to as
- the configuration of an Opus packet.
+The TOC sequence at the beginning of each Opus packet indicates the coding
+ mode, audio bandwidth, channel count, duration (frame size), and number of
+ frames per packet, as described in Section&nbsp;3.1
+ of&nbsp;<xref target="RFC6716"/>.
+The coding mode is one of SILK, Hybrid, or Constrained Energy Lapped Transform
+ (CELT).
+The combination of coding mode, audio bandwidth, and frame size is referred to
+ as the configuration of an Opus packet.
 </t>
 <t>
 The first audio data page SHOULD NOT have the 'continued packet' flag set
  (which would indicate the first audio data packet is continued from a previous
  page).
 Packets MUST be placed into Ogg pages in order until the end of stream.
 Audio packets MAY span page boundaries.
 An implementation MUST treat a zero-octet audio data packet as if it were a
@@ -264,18 +260,19 @@ All other pages with completed packets after the first MUST have a granule
 This guarantees that a demuxer can assign individual packets the same granule
  position when working forwards as when working backwards.
 For this to work, there cannot be any gaps.
 </t>
 
 <section anchor="gap-repair" title="Repairing Gaps in Real-time Streams">
 <t>
 In order to support capturing a real-time stream that has lost or not
- transmitted packets, a muxer SHOULD emit packets that explicitly request the
- use of Packet Loss Concealment (PLC) in place of the missing packets.
+ transmitted packets, a multiplexer (muxer) SHOULD emit packets that explicitly
+ request the use of Packet Loss Concealment (PLC) in place of the missing
+ packets.
 Implementations that fail to do so still MUST NOT increment the granule
  position for a page by anything other than the number of samples contained in
  packets that actually complete on that page.
 </t>
 <t>
 Only gaps that are a multiple of 2.5&nbsp;ms are repairable, as these are the
  only durations that can be created by packet loss or discontinuous
  transmission.
@@ -374,21 +371,21 @@ Therefore, the first few samples produced by the decoder do not correspond to
 These samples need to be stored and decoded, as Opus is an asymptotically
  convergent predictive codec, meaning the decoded contents of each frame depend
  on the recent history of decoder inputs.
 However, a player will want to skip these samples after decoding them.
 </t>
 
 <t>
 A 'pre-skip' field in the ID header (see <xref target="id_header"/>) signals
- the number of samples which SHOULD be skipped (decoded but discarded) at the
+ the number of samples that SHOULD be skipped (decoded but discarded) at the
  beginning of the stream.
 This amount need not be a multiple of 2.5&nbsp;ms, MAY be smaller than a single
  packet, or MAY span the contents of several packets.
-These samples are not valid audio, and SHOULD NOT be played.
+These samples are not valid audio.
 </t>
 
 <t>
 For example, if the first Opus frame uses the CELT mode, it will always
  produce 120 samples of windowed overlap-add data.
 However, the overlap data is initially all zeros (since there is no prior
  frame), meaning this cannot, in general, accurately represent the original
  audio.
@@ -639,16 +636,17 @@ This is the number of samples (at 48&nbsp;kHz) to discard from the decoder
 When cropping the beginning of existing Ogg Opus streams, a pre-skip of at
  least 3,840&nbsp;samples (80&nbsp;ms) is RECOMMENDED to ensure complete
  convergence in the decoder.
 <vspace blankLines="1"/>
 </t>
 <t>Input Sample Rate (32 bits, unsigned, little
  endian):
 <vspace blankLines="1"/>
+This is the sample rate of the original input (before encoding), in Hz.
 This field is <spanx style="emph">not</spanx> the sample rate to use for
  playback of the encoded data.
 <vspace blankLines="1"/>
 Opus can switch between internal audio bandwidths of 4, 6, 8, 12, and
  20&nbsp;kHz.
 Each packet in the stream can have a different audio bandwidth.
 Regardless of the audio bandwidth, the reference decoder supports decoding any
  stream at a sample rate of 8, 12, 16, 24, or 48&nbsp;kHz.
@@ -696,17 +694,17 @@ It is 20*log10 of the factor by which to scale the decoder output to achieve
 To apply the gain, an implementation could use
 <figure align="center">
 <artwork align="center"><![CDATA[
 sample *= pow(10, output_gain/(20.0*256)) ,
 ]]></artwork>
 </figure>
  where output_gain is the raw 16-bit value from the header.
 <vspace blankLines="1"/>
-Virtually all players and media frameworks SHOULD apply it by default.
+Players and media frameworks SHOULD apply it by default.
 If a player chooses to apply any volume adjustment or gain modification, such
  as the R128_TRACK_GAIN (see <xref target="comment_header"/>), the adjustment
  MUST be applied in addition to this output gain in order to achieve playback
  at the normalized volume.
 <vspace blankLines="1"/>
 A muxer SHOULD set this field to zero, and instead apply any gain prior to
  encoding, when this is possible and does not conflict with the user's wishes.
 A nonzero output gain indicates the gain was adjusted after encoding, or that
@@ -720,36 +718,34 @@ The large range serves in part to ensure that gain can always be losslessly
  transferred between OpusHead and R128 gain tags (see below) without
  saturating.
 <vspace blankLines="1"/>
 </t>
 <t>Channel Mapping Family (8 bits, unsigned):
 <vspace blankLines="1"/>
 This octet indicates the order and semantic meaning of the output channels.
 <vspace blankLines="1"/>
-Each possible value of this octet indicates a mapping family, which defines a
- set of allowed channel counts, and the ordered set of channel names for each
- allowed channel count.
+Each currently specified value of this octet indicates a mapping family, which
+ defines a set of allowed channel counts, and the ordered set of channel names
+ for each allowed channel count.
 The details are described in <xref target="channel_mapping"/>.
 </t>
 <t>Channel Mapping Table:
 This table defines the mapping from encoded streams to output channels.
-It MUST be omitted when the channel mapping family is 0, but is
- REQUIRED otherwise.
 Its contents are specified in <xref target="channel_mapping"/>.
 </t>
 </list>
 </t>
 
 <t>
 All fields in the ID headers are REQUIRED, except for the channel mapping
  table, which MUST be omitted when the channel mapping family is 0, but
  is REQUIRED otherwise.
-Implementations SHOULD reject ID headers which do not contain enough data for
- these fields, even if they contain a valid Magic Signature.
+Implementations SHOULD reject streams with ID headers that do not contain
+ enough data for these fields, even if they contain a valid Magic Signature.
 Future versions of this specification, even backwards-compatible versions,
  might include additional fields in the ID header.
 If an ID header has a compatible major version, but a larger minor version,
  an implementation MUST NOT reject it for containing additional data not
  specified here, provided it still completes on the first page.
 </t>
 
 <section anchor="channel_mapping" title="Channel Mapping">
@@ -869,17 +865,17 @@ Special mapping: This channel mapping value also
 When the 'channel mapping family' octet has this value, the channel mapping
  table MUST be omitted from the ID header packet.
 </t>
 </section>
 
 <section anchor="channel_mapping_1" title="Channel Mapping Family 1">
 <t>
 Allowed numbers of channels: 1...8.
-Vorbis channel order.
+Vorbis channel order (see below).
 </t>
 <t>
 Each channel is assigned to a speaker location in a conventional surround
  arrangement.
 Specific locations depend on the number of channels, and are given below
  in order of the corresponding channel indices.
 <list style="symbols">
   <t>1 channel: monophonic (mono).</t>
@@ -892,17 +888,17 @@ Specific locations depend on the number of channels, and are given below
   <t>8 channels: 7.1 surround (front&nbsp;left, front&nbsp;center, front&nbsp;right, side&nbsp;left, side&nbsp;right, rear&nbsp;left, rear&nbsp;right, LFE)</t>
 </list>
 </t>
 <t>
 This set of surround options and speaker location orderings is the same
  as those used by the Vorbis codec <xref target="vorbis-mapping"/>.
 The ordering is different from the one used by the
  WAVE <xref target="wave-multichannel"/> and
- FLAC <xref target="flac"/> formats,
+ Free Lossless Audio Codec (FLAC) <xref target="flac"/> formats,
  so correct ordering requires permutation of the output channels when decoding
  to or encoding from those formats.
 'LFE' here refers to a Low Frequency Effects channel, often mapped to a
   subwoofer with no particular spatial position.
 Implementations SHOULD identify 'side' or 'rear' speaker locations with
  'surround' and 'back' as appropriate when interfacing with audio formats
  or systems which prefer that terminology.
 </t>
@@ -924,18 +920,18 @@ Implementations SHOULD NOT produce output for channels mapped to stream index
  non-silent channels.
 </t>
 </section>
 
 <section anchor="channel_mapping_undefined"
  title="Undefined Channel Mappings">
 <t>
 The remaining channel mapping families (2...254) are reserved.
-An implementation encountering a reserved channel mapping family value SHOULD
- act as though the value is 255.
+A demuxer implementation encountering a reserved channel mapping family value
+ SHOULD act as though the value is 255.
 </t>
 </section>
 
 <section anchor="downmix" title="Downmixing">
 <t>
 An Ogg Opus player MUST support any valid channel mapping with a channel
  mapping family of 0 or 1, even if the number of channels does not match the
  physically connected audio hardware.
@@ -1188,17 +1184,17 @@ If the least-significant bit of the first byte of this data is 1, then editors
  SHOULD preserve the contents of this data when updating the tags, but if this
  bit is 0, all such data MAY be treated as padding, and truncated or discarded
  as desired.
 </t>
 
 <t>
 The comment header can be arbitrarily large and might be spread over a large
  number of Ogg pages.
-Implementations SHOULD avoid attempting to allocate excessive amounts of memory
+Implementations MUST avoid attempting to allocate excessive amounts of memory
  when presented with a very large comment header.
 To accomplish this, implementations MAY reject a comment header larger than
  125,829,120&nbsp;octets, and MAY ignore individual comments that are not fully
  contained within the first 61,440 octets of the comment header.
 </t>
 
 <section anchor="comment_format" title="Tag Definitions">
 <t>
@@ -1233,35 +1229,35 @@ R128_ALBUM_GAIN=111
 </figure>
 <t>
  representing the volume shift needed to normalize the overall volume when
  played as part of a particular collection of tracks.
 The gain is also a Q7.8 fixed point number in dB, as in the ID header's
  'output gain' field.
 </t>
 <t>
-An Ogg Opus stream MUST NOT have more than one of each tag, and if present
- their values MUST be an integer from -32768 to 32767, inclusive,
+An Ogg Opus stream MUST NOT have more than one of each of these tags, and if
+ present their values MUST be an integer from -32768 to 32767, inclusive,
  represented in ASCII as a base 10 number with no whitespace.
 A leading '+' or '-' character is valid.
 Leading zeros are also permitted, but the value MUST be represented by
  no more than 6 characters.
 Other non-digit characters MUST NOT be present.
 </t>
 <t>
 If present, R128_TRACK_GAIN and R128_ALBUM_GAIN MUST correctly represent
  the R128 normalization gain relative to the 'output gain' field specified
  in the ID header.
 If a player chooses to make use of the R128_TRACK_GAIN tag or the
  R128_ALBUM_GAIN tag, it MUST apply those gains
  <spanx style="emph">in addition</spanx> to the 'output gain' value.
 If a tool modifies the ID header's 'output gain' field, it MUST also update or
  remove the R128_TRACK_GAIN and R128_ALBUM_GAIN comment tags if present.
-A muxer SHOULD assume that by default tools will respect the 'output gain'
- field, and not the comment tag.
+A muxer SHOULD place the gain it wants other tools to use by default into the
+ 'output gain' field, and not the comment tag.
 </t>
 <t>
 To avoid confusion with multiple normalization schemes, an Opus comment header
  SHOULD NOT contain any of the REPLAYGAIN_TRACK_GAIN, REPLAYGAIN_TRACK_PEAK,
  REPLAYGAIN_ALBUM_GAIN, or REPLAYGAIN_ALBUM_PEAK tags.
 <xref target="EBU-R128"/> normalization is preferred to the earlier
  REPLAYGAIN schemes because of its clear definition and adoption by industry.
 Peak normalizations are difficult to calculate reliably for lossy codecs
@@ -1277,20 +1273,21 @@ In the authors' investigations they were not applied consistently or broadly
 <section anchor="packet_size_limits" title="Packet Size Limits">
 <t>
 Technically, valid Opus packets can be arbitrarily large due to the padding
  format, although the amount of non-padding data they can contain is bounded.
 These packets might be spread over a similarly enormous number of Ogg pages.
 When encoding, implementations SHOULD limit the use of padding in audio data
  packets to no more than is necessary to make a variable bitrate (VBR) stream
  constant bitrate (CBR).
-Demuxers SHOULD reject audio data packets larger than 61,440 octets per
+Demuxers SHOULD reject audio data packets (treat them as if they were malformed
+ Opus packets with an invalid TOC sequence) larger than 61,440 octets per
  Opus stream.
 Such packets necessarily contain more padding than needed for this purpose.
-Demuxers SHOULD avoid attempting to allocate excessive amounts of memory when
+Demuxers MUST avoid attempting to allocate excessive amounts of memory when
  presented with a very large packet.
 Demuxers MAY reject or partially process audio data packets larger than
  61,440&nbsp;octets in an Ogg Opus stream with channel mapping families&nbsp;0
  or&nbsp;1.
 Demuxers MAY reject or partially process audio data packets in any Ogg Opus
  stream if the packet is larger than 61,440&nbsp;octets and also larger than
  7,680&nbsp;octets per Opus stream.
 The presence of an extremely large packet in the stream could indicate a
@@ -1331,18 +1328,19 @@ This gives a size of 61,310&nbsp;octets, which is rounded up to a multiple of
 </section>
 
 <section anchor="encoder" title="Encoder Guidelines">
 <t>
 When encoding Opus streams, Ogg muxers SHOULD take into account the
  algorithmic delay of the Opus encoder.
 </t>
 <t>
-In encoders derived from the reference implementation, the number of
- samples can be queried with:
+In encoders derived from the reference
+ implementation&nbsp;<xref target="RFC6716"/>, the number of samples can be
+ queried with:
 </t>
 <figure align="center">
 <artwork align="center"><![CDATA[
  opus_encoder_ctl(encoder_state, OPUS_GET_LOOKAHEAD(&delay_samples));
 ]]></artwork>
 </figure>
 <t>
 To achieve good quality in the very first samples of a stream, implementations
@@ -1545,16 +1543,17 @@ The authors agree to grant third parties the irrevocable right to copy, use,
 </section>
 
 </middle>
 <back>
 <references title="Normative References">
  &rfc2119;
  &rfc3533;
  &rfc3629;
+ &rfc4732;
  &rfc5334;
  &rfc6381;
  &rfc6716;
 
 <reference anchor="EBU-R128" target="https://tech.ebu.ch/loudness">
 <front>
   <title>Loudness Recommendation EBU R128</title>
   <author>
@@ -1575,17 +1574,16 @@ The authors agree to grant third parties the irrevocable right to copy, use,
 </front>
 </reference>
 
 </references>
 
 <references title="Informative References">
 
 <!--?rfc include="http://xml.resource.org/public/rfc/bibxml/reference.RFC.3550.xml"?-->
- &rfc4732;
  &rfc6982;
  &rfc7587;
 
 <reference anchor="flac"
  target="https://xiph.org/flac/format.html">
   <front>
     <title>FLAC - Free Lossless Audio Codec Format Description</title>
     <author initials="J." surname="Coalson" fullname="Josh Coalson"/>

---

From: Ron <[email-masked]>
Date: Sat, 12 Dec 2015 10:22:03 +1030

> Thank you for the very thorough review. Comments in-line below (as an

Indeed.  I think Tim has already covered most of my thoughts here, so
just a couple of extra things:

> Some specific applications might have a reason for looking at that data (for
> example, when you have multiple files that you know were produced by
> chopping up a single existing file without re-encoding). In practice we
> haven't needed anything stronger to convince people to implement this

We might still want to clarify "These samples are not valid audio." at
the end of that second paragraph - since as the last paragraph points
out, some of them may actually be valid but just cropped for
synchronisation or other aesthetic reasons.

Maybe just moving that sentence up to the end of the first paragraph
instead would make a bit more sense?  Since it's the samples which
are described there which are not valid audio, while the pre-skip
field itself may overlap both those and some additional valid audio.

> >- 5.1.1.4: Why not MUST?
> 
> I think the idea was to allow assigning reserved values without explicitly
> updating this specification. Even though I expect we _would_ want to update
> this specification, given how long it's taken to get this draft published,
> I'm wary of adding more pressure to people not to deploy new mappings
> (because this RFC says they MUST not), even when it looks like they'll be
> relatively stable and interoperable. At least not for the sole reason that
> they haven't gotten an RFC number yet.

Mark Harris and I had some discussion about this in the light of whether
it should be MUST or SHOULD - and perhaps the most interesting thing to
come out of that was wondering if we should in fact offer some advice on
ways that people can safely use experimental new mappings before a new
channel mapping number has been allocated for them.

One option would be to suggest they use mapping 255 (which existing
decoders SHOULD/MUST ignore) along with a special comment field of
their own choosing which allows experimental decoders to know how to
treat that stream.

If the experiment fails, we lose an arbitrary unique name in the comment
space, if it succeeds and gets consensus, we can add a mapping for it,
and decoders can continue to recognise both the magic comment and the
new mapping as appropriate.  But we don't end up with incompatible uses
for the same mapping number.

It may be a bit late in the game to be adding something like that to
this document - but we probably also don't strictly need to, since it
doesn't change anything that is already normatively specified, it would
just offer advice about how to proceed if you are developing a new
mapping.  Which means maybe it's also uncontroversial to add it too?

> This text was specifically requested by the Debian project (and I support it
> personally). The same issue came up for RFC 6716 (for the same reasons). See
> the discussion at
> Reviewing those conversations, I do notice that the language of that section
> was changed after last call for RFC 6716, but the corresponding language in
> our source repository was not updated (because it was added to the document
> boilerplate manually by the RFC Editor, and not included in a separate
> section).

Yes, I think this probably needs to be changed to something more like
what IETF legal suggested for RFC 6716, granting "the right to extract
sections 1 - 14 ...".  This allows people to make liberal use of the
details in this document, but ensures they can't misrepresent any such
use as somehow being an RFC.

  Cheers,
  Ron

---

From: "Timothy B. Terriberry" <[email-masked]>
Date: Mon, 14 Dec 2015 14:56:29 -0800

> mapping.  Which means maybe it's also uncontroversial to add it too?

I think my preference would be to leave it out. We had many of these 
extension points in Vorbis (transform type, floor type, residue type, 
mapping type, window type), and there were never any conflicts. Having 
an explicit "255 == unidentified" mapping is already more machinery than 
Vorbis had. Let's not invent more complications we don't know we need.

---

From: "Ben Campbell" <[email-masked]>
Date: Fri, 18 Dec 2015 18:19:32 -0600

Thanks for the response. A few more comments on the substantive section 
inline. I will get to the editorial parts in a separate email. (I 
removed sections that do not seem to need further discussion.)

Thanks!

Ben.

On 11 Dec 2015, at 16:16, Timothy B. Terriberry wrote:

[...]

> I think the intent was just to point out that someone might violate 
> the preceding SHOULD. It's not clear what actionable thing we'd be 
> saying they MUST do (it would depend on the particular 
> implementation).

I guess you can say MUST gracefully handle...

That makes me wonder why the end-of-stream flag part is a SHOULD and not 
a MUST, though. Are there reasonable circumstances to violate that 
SHOULD?

> drops at some point, you might reasonably expect to just be able to 
> copy the data you received to a file. A MUST here would mean you would 
> have to parse the pages, identify the continued packets from the 
> lacing values, remove the extraneous data from the last page if you 
> found some, repack the page buffer, and recompute the page checksum. 
> That's a lot more machinery, and people would likely just ignore the 
> requirement in practice. See also the discussion at 

As stated, it still requires that extra work, unless the implementor has 
a really good reason and fully understands the consequences. In this 
case, it seems to mean SHOULD do that work unless you don't want to.

I guess this really depends on how strongly you want to discourage the 
behavior, and what breaks if people ignore that discouragement. This 
might be better stated as non-normative guidance. Given that an 
implementation has to be able to deal with a continued packet last page 
anyway, does it really matter?

If you want to keep it as a SHOULD NOT, it would be helpful to mention 
the reasonable violations you envision in the text.

> Some specific applications might have a reason for looking at that 
> data (for example, when you have multiple files that you know were 
> produced by chopping up a single existing file without re-encoding).

It would be helpful to mention that in the text.

> In practice we haven't needed anything stronger to convince people to 
> implement this correctly (especially when we point them to 

I'm not don't think that SHOULD vs MUST logic is contemplated by RFC 
2119 :-) It's not so much how big of a stick you need to get people to 
do the right thing as it is how bad do things break if people do the 
wrong thing. (I do agree with the sentiment to not put in MUSTs that you 
know people won't pay attention to, but I don't think thats the case 
here.)

[...]

> people familiar with how Vorbis works what mechanism they should use 
> to achieve the same outcome in Opus. But if you're not familiar with 

Okay.

> It is possible to implement seeking without knowing anything other 
> than what is described in RFC 3533, but the linked documentation does 
> help considerably.
>
> scanning the whole file on open to build an index, possibly caching 
> such indexes for files that are opened frequently: this would not be 
> my recommended approach, but people have done it in practice). You 
> could also choose to implement only approximate seeking by just 
> guessing a file position and decoding from there (also done in 
> practice by some players, and a common method for other formats like 
> MP3). Or you could choose not to implement seeking at all.

The current wording says "see [seeking] for general implementation 
guidelines." If those are optional guidelines, it would help to say so, 
or describe it as "some example guidelines". OTOH, if you really prefer 
the approach in [seeking], then it still makes sense for it to be 
normative.

A reference required to understand and implement an optional feature 
should still be normative.

[...]

> it). Changed to say that instead.

Which "that"?

Maybe this is a conventional way to say things in the codec community, 
but when I see "reject" I usually think that means you generate some 
sort of error back to the source of the thing you reject. (As opposed to 
"ignore")

> explicitly updating this specification. Even though I expect we 
> _would_ want to update this specification, given how long it's taken 
> to get this draft published, I'm wary of adding more pressure to 
> people not to deploy new mappings (because this RFC says they MUST 
> not), even when it looks like they'll be relatively stable and 
> interoperable. At least not for the sole reason that they haven't 
> gotten an RFC number yet.

If this spec reserves those values, then people still need to update it 
to assign them. If you want to make it extensible, then perhaps it needs 
an IANA registry, which, depending on the assignment policy, may not 
require an RFC at all (seems like "expert review" or "specification 
required" might make sense).

Or if you want people to be able to play with other mappings without 
"officially" assigning values, you could make some or all of the range 
"for experimental use".

> specification may eventually define the format of the data here and 
> how to modify it, and I didn't think we'd want to make people 
> supporting that specification in violation of this specification. I'm 
> also leaning towards keeping this one a SHOULD since a) the eventual 
> format of this data may apply to all codecs which share the 
> vorbiscomment style of metadata, and b) we would probably try to do 
> this informally first to gain implementation experience, and only 
> bring it to the IETF if there is sufficient interest. I didn't want to 
> make updating this document a prerequisite for that. See also the 
> discussion in this thread: 
> <https://www.ietf.org/mail-archive/web/codec/current/msg03107.html> 
> for the resolution of the debate).

I don't think the fact that future specs might change something is an 
appropriate reason to pick SHOULD vs MUST. That's _always_ true, and 
it's what our "UPDATES" process is for. The idea that you might want to 
informally experiment with different approaches is more convincing. But 
if that is the case, it would be helpful to have a sentence to that 
effect in the text.
> call like "excessive". I have no objection to changing it to MUST.

I think the consequences of not following the advice is the important 
point. It sounds like this could be important for DoS attack avoidance, 
and maybe even for buffer-overrun type things. Those fall into the 
category of Bad Things.

(I do agree "Excessive" is a bit vague, so if there were a way to state 
this more concretely it would improve things. But that's true for a 
SHOULD as much as for a MUST).

[...]

> In some contexts, there may be no confusion with multiple 
> normalization schemes. The language in this section was debated a good 
> deal on the list (see threads 
> <https://www.ietf.org/mail-archive/web/codec/current/msg03053.html>). 
> I believe everyone is satisfied with the current compromise, and would 

I agree that SHOULD NOT may be appropriate here. My point is the text 
should explain why. Almost anytime a SHOULD occurs, it's helpful to 
include text describing why a MUST is not appropriate. (Usually in the 
form of examples or reasons the authors think would be appropriate to 
violate the SHOULD).

> such packets is enough to discourage encoders from emitting them, and 
> I was wary of imposing a MUST restriction when RFC 6716 chose not to 
> do so.

Did 6716 use a SHOULD?

I assume that any 2119 keywords in this draft are intended to further 
restrict things from 6716. If it's already covered normatively there, 
then it doesn't need 2119 keywords here (unless directly quoted or 
attributed). But in any case, I'm looking for justification in the text. 
(I do consider preventing the use of excessive bandwidth a good enough 
reason for a MUST

>
> For the second, this is the same as the previous comment about 
> excessive allocations. I have no objection to changing this one, 
> either.

I realize now there were 3 SHOULDs in that paragraph. I mean the one 
about avoiding excessive allocations. It sounds like

[...]

> to include a reference to help those who might not be DSP engineers 
> but wanted to learn more.

Please consider saying something like "For more information on linear 
prediction, see [XXX]." As it's currently stated, it looks like it says 
MAY do X, where the reference specified X, which would require a 
normative reference.

[...]

> section was changed after last call for RFC 6716, but the 
> corresponding language in our source repository was not updated 
> (because it was added to the document boilerplate manually by the RFC 
> Editor, and not included in a separate section).

That language is a bit of a problem for a standards track RFC. If people 
are really attached to it, we can pursue allowing it. But I expect 
objections down the line. Keep in mind "NOTE WELL" says that any 
contributions are subject to the rules of BCP 78 and 79.

In any case, 6716 is a bit more code centric , so the discussion made 
more sense there.

---

From: "Ben Campbell" <[email-masked]>
Date: Mon, 21 Dec 2015 15:31:07 -0600

Hi,

Here are my comments to your responses to my editorial comments. As 
before, I removed sections that do not seem to need further comment.

Thanks!

Ben.

[...]

[...]

>> available
> It is a little bit more complicated. There are two rates here: one 
> used for decoding, and one used for playback. The difference between 
> steps 2 and 3 is that in step 3, the hardware's highest available 
> sample rate is not one of the rates supported by Opus decoding. For 
> example, if the highest available sample rate the hardware can handle 
> is 32 kHz, then this is not a "supported rate" (i.e., not supported by 
> Opus decoding), so step 2 does not apply and step 3 does. Step 3 says 
> to decode at the next highest "supported rate", which would be 48 kHz, 
> and then resample to a rate the hardware can handle (in this case 32 
> kHz).
>

I think I see. The point is that you decode rate still does not match 
the hardware rate, thus the resampling? OTOH, I now find myself confused 
by "next highest supported rate above this". Does "this" refer to the 
"hardware’s highest available sample rate"? So the decode rate is 
always equal to or higher than the hardware playback rate?

[...]
>> 5334” field in the initial heading.

I didn't see a response to this one.

---

From: "Timothy B. Terriberry" <[email-masked]>
Date: Mon, 21 Dec 2015 13:43:33 -0800

A fast response because these are easy:

Ben Campbell wrote:
> "hardware’s highest available sample rate"? So the decode rate is always
> equal to or higher than the hardware playback rate?

Correct (except possibly if the hardware supports rates higher than 48 
kHz, in which case step 4 might apply).

---

From: "Ben Campbell" <[email-masked]>
Date: Mon, 21 Dec 2015 16:14:27 -0600

On 11 Dec 2015, at 17:52, Ron wrote:

[I have no opinion on the "not valid audio samples" discussion.]

>> explicitly

It's a common practice to mark certain code points or ranges as 
"experimental" in IETF specs.

> mapping.  Which means maybe it's also uncontroversial to add it too?

I think adding that at this point would require mention on the working 
group list, to give people a chance to object. But that's not difficult.

>> support it
>> section

Using the modified boilerplate from RFC 6716 would make more sense, if 
this document really needs it. But why does this document need it? It 
doesn't include code (normative or otherwise) like 6716. Or more to the 
point, why does this document need the extra grants more than any other 
standards-track RFC?

Thanks!

Ben.

---

From: "Ben Campbell" <[email-masked]>
Date: Mon, 21 Dec 2015 16:21:10 -0600

On 21 Dec 2015, at 15:43, Timothy B. Terriberry wrote:

>> always

Got it. But I still think the "this" is ambiguous (between "highest 
hardware rate" and 48khz). So I propose:

OLD:
Otherwise, if the hardware’s highest available sample rate is less 
than 48 kHz, decode at the next highest supported rate above this and 
resample.
NEW:
Otherwise, if the hardware’s highest available sample rate is less 
than 48 kHz, decode at the next higher Opus supported rate above the 
hardware rate and resample to the hardware rate.
END

---

From: "Timothy B. Terriberry" <[email-masked]>
Date: Mon, 21 Dec 2015 14:44:59 -0800

Ben Campbell wrote:
> OLD:
> Otherwise, if the hardware’s highest available sample rate is less than
> 48 kHz, decode at the next highest supported rate above this and resample.
> NEW:
> Otherwise, if the hardware’s highest available sample rate is less than
> 48 kHz, decode at the next higher Opus supported rate above the hardware
> rate and resample to the hardware rate.
> END

Okay, I've incorporated these changes into my local edits (though I used 
"above the highest available hardware rate" instead of just "above the 
hardware rate" so that it's extra clear we're talking about the same one).

---

From: Ron <[email-masked]>
Date: Wed, 23 Dec 2015 07:01:47 +1030

On Mon, Dec 21, 2015 at 04:14:27PM -0600, Ben Campbell wrote:
> I think adding that at this point would require mention on the working group
> list, to give people a chance to object. But that's not difficult.

I don't feel a strong need to see this added, but I mentioned it precisely
because it did seem like a discussion that should be aired on the list, if
only as a reminder for later about why we didn't do this and a note that
we did think about it.

I think Tim was already looking into what we need to do to set up an
IANA registry for this.  Which is seeming like it's probably the right
thing here.

> Using the modified boilerplate from RFC 6716 would make more sense, if this
> document really needs it. But why does this document need it? It doesn't
> include code (normative or otherwise) like 6716. Or more to the point, why
> does this document need the extra grants more than any other standards-track
> RFC?

The crux here is twofold.  We have organisations including, but not
limited to, Debian, who cannot distribute this included with an
implementation of it, unless it also grants people the right to
redistribute potentially modified versions of it.  A restriction
which prevents people from claiming that a modified version is an
RFC is fine, but people need to be able to cut selected parts out
of it (possibly to include just selected parts in the documentation
of their own library or applications), and/or adapt them for other
purposes too.

But beyond that, this document itself cribbed as much as we could
from the work of other previous Ogg mappings, and includes things
which are more generally useful, like the channel mapping definitions
and the downmixing matrices, just to pick two.

So it's not unreasonable to think this may in turn be a base which
future work is built on, and in fact we'd encourage that, because
it's definitely good not to change things that aren't broken and
don't need changing for other future mappings.

We'd also encourage that work to ultimately end up in an IETF working
group too - but any initial work at least is quite likely to start
outside of one until things are proven enough to take that next step.

Ultimately, the rationale for this is actually almost identical to
6716, the only difference is 6716 created the weird situation where
the normative part *was* the code, and it was already covered by a
grant even more liberal than what we'd like for the descriptive text.

The alternative (which we discussed with Robert Sparks for 6716) is
the authors could publish a separate "this is not an RFC" version
outside of the IETF with the extra grants - but that didn't seem like
it would create less confusion than the solution IETF legal arrived
at - which seems pretty close to ideal for any document that might
be the basis for future or continuing work.

We don't want people to be claiming that modified versions are an RFC,
but we would like them to be able to reuse anything out of this that
it makes sense to, as freely as we can allow them to.  Otherwise we
just artificially stifle further progress (or force everyone to turn
a blind eye when people do things we didn't explicitly grant them
the right to do - and that is the part I think we all share the desire
to avoid).

  Cheers,
  Ron

---

From: "Timothy B. Terriberry" <[email-masked]>
Date: Mon, 28 Dec 2015 05:00:33 -0800

Ben Campbell wrote:
> a MUST, though. Are there reasonable circumstances to violate that SHOULD?

The usual case is again, saving a live stream that gets interrupted 
before it ends.

> This might be better stated as non-normative guidance.

Given that this is a general Ogg requirement, and not really 
Opus-specific, I think you are right.

Here are the changes I propose:

-The first audio data page SHOULD NOT have the 'continued packet' flag set
- (which would indicate the first audio data packet is continued from a 
previous
- page).
-Packets MUST be placed into Ogg pages in order until the end of stream.
-Audio packets MAY span page boundaries.
+Packets are placed into Ogg pages in order until the end of stream.
+Audio data packets might span page boundaries.
+The first audio data page could have the 'continued packet' flag set
+ (indicating the first audio data packet is continued from a previous 
page) if,
+ for example, it was a live stream joined mid-broadcast, with the headers
+ pasted on the front.
+A demuxer SHOULD NOT attempt to decode the data for the first packet on 
a page
+ with the 'continued packet' flag set if the previous page with packet data
+ does not end in a continued packet (i.e., did not end with a lacing 
value of
+ 255) or if the page sequence numbers are not consecutive, unless the 
demuxer
+ has some special knowledge that would allow it to interpret this data
+ despite the missing pieces.

Along with

-The last page SHOULD have the 'end of stream' flag set, but implementations
- need to be prepared to deal with truncated streams that do not have a page
- marked 'end of stream'.
-The final packet on the last page SHOULD NOT be a continued packet, 
i.e., the
- final lacing value SHOULD be less than 255.
+A logical stream ends with a page with the 'end of stream' flag set, but
+ implementations need to be prepared to deal with truncated streams 
that do not
+ have a page marked 'end of stream'.
+There is no reason for the final packet on the last page to be a continued
+ packet, i.e., for the final lacing value to be less than 255.
+However, demuxers might encounter such streams, possibly as the result of a
+ transfer that did not complete or of corruption.
+A demuxer SHOULD NOT attempt to decode the data from a packet that 
continues
+ onto a subsequent page (i.e., when the page ends with a lacing value 
of 255)
+ if the next page with packet data does not have the 'continued packet' 
flag
+ set or does not exist, or if the page sequence numbers are not 
consecutive,
+ unless the demuxer has some special knowledge that would allow it to 
interpret
+ this data despite the missing pieces.

That gives specific guidance on what a demuxer needs to do to avoid 
corrupting the Opus state machine with garbage data (which is generally 
worse for Opus than simply skipping decode of a packet). It is also what 
is most broadly implemented.

> It would be helpful to mention that in the text.

I added something about that.

> wrong thing. (I do agree with the sentiment to not put in MUSTs that you

Given that historically, many audio formats (including MP3) did not 
support sample-accurate durations at all, I don't think the world ends. 
But it certainly would break features like gapless playback that some 
users find important.

> the approach in [seeking], then it still makes sense for it to be

I've added the optional/example qualifier.

I also updated the claim on the number of bisections required, as our 
implementations have improved since the draft was first written.

>> it). Changed to say that instead.

To quote the attached diff:

-Implementations SHOULD reject ID headers which do not contain enough 
data for
- these fields, even if they contain a valid Magic Signature.
+Implementations SHOULD reject streams with ID headers that do not contain
+ enough data for these fields, even if they contain a valid Magic 
Signature.

> sort of error back to the source of the thing you reject. (As opposed to

Well, the most likely behavior here is to tell the user that the file is 
not a valid Ogg Opus file, so your sense of "generating some sort of 
error back" is in fact correct. But that makes some application-level 
assumptions I'm not sure I'm comfortable writing normative text around. 
Any ideas for a better way to phrase this?

> required" might make sense).

An IANA registry actually does not seem like a terrible idea. Reading 
RFC 5226 it doesn't seem too hard to set one up. I attempted to draft 
some text.

> if that is the case, it would be helpful to have a sentence to that

Okay, I will add one.

> SHOULD as much as for a MUST).

The problem is that it depends very much on context. 60 kB might already 
be seen as excessive for an embedded system, but would never be noticed 
on a desktop.

> should explain why. Almost anytime a SHOULD occurs, it's helpful to

I agree with your point very much in principle. We just may not have 
been as careful about it in practice as we should have been (and I 
appreciate you forcing us to clarify our thinking now). I'll add 
something to the effect of what I said above.

> Did 6716 use a SHOULD?

It imposed no restrictions on the amount of padding at all.

> (I do consider preventing the use of excessive bandwidth a good enough

I attempted to add some.

>> excessive allocations. I have no objection to changing this one, either.
>

You may have forgotten to complete your thought here.

> MAY do X, where the reference specified X, which would require a

That's a good suggestion. Done.

> That language is a bit of a problem for a standards track RFC. If people

You mean the current text, or the actual text that wound up in RFC 6716?

> contributions are subject to the rules of BCP 78 and 79.

Yes, I think this has more to do with letting people use such 
contributions _outside_ the context of the IETF (i.e., it grants 
additional rights to those already granted in BCP 78 and 79, which I 
understand is allowed).

You are probably right about people objecting down the line (again), but 
I am happy to address those objections when they come, as we did for RFC 
6716.

> In any case, 6716 is a bit more code centric , so the discussion made

Well, from our point of view, the XML source for both RFCs is included 
in the repository with libopus, which is distributed in Debian. If we 
didn't have some kind of grant like this, they would have to somehow 
strip those documents out. So it is not so much the code being in the 
RFC as the draft being distributed with the code.

In any case, I have attempted to draft an RFC Editor's note requesting 
the same text that RFC 6716 used. Since that text grants a license from 
the IETF Trust, instead of the authors, I assume that someone from the 
Trust will have to approve of it, however (and reading 
<http://www.ietf.org/proceedings/85/slides/slides-85-iesg-opsandtech-15.ppt> 
it seems that the current opinion of the Trust is that this approach is 
legally required).

I have also gone through and finished removing the 2119 language for 
general Ogg requirements.

The diff of all changes is attached. If these look good (or if it's 
simply helps in reviewing them) I can publish a new version.
diff --git a/doc/draft-ietf-codec-oggopus.xml b/doc/draft-ietf-codec-oggopus.xml
index b95e5bc..7489c20 100644
--- a/doc/draft-ietf-codec-oggopus.xml
+++ b/doc/draft-ietf-codec-oggopus.xml
@@ -1,14 +1,15 @@
 <?xml version="1.0" encoding="utf-8"?>
 <!DOCTYPE rfc SYSTEM 'rfc2629.dtd' [
 <!ENTITY rfc2119 PUBLIC '' 'http://xml.resource.org/public/rfc/bibxml/reference.RFC.2119.xml'>
 <!ENTITY rfc3533 PUBLIC '' 'http://xml.resource.org/public/rfc/bibxml/reference.RFC.3533.xml'>
 <!ENTITY rfc3629 PUBLIC '' 'http://xml.resource.org/public/rfc/bibxml/reference.RFC.3629.xml'>
 <!ENTITY rfc4732 PUBLIC '' 'http://xml.resource.org/public/rfc/bibxml/reference.RFC.4732.xml'>
+<!ENTITY rfc5226 PUBLIC '' 'http://xml.resource.org/public/rfc/bibxml/reference.RFC.5226.xml'>
 <!ENTITY rfc5334 PUBLIC '' 'http://xml.resource.org/public/rfc/bibxml/reference.RFC.5334.xml'>
 <!ENTITY rfc6381 PUBLIC '' 'http://xml.resource.org/public/rfc/bibxml/reference.RFC.6381.xml'>
 <!ENTITY rfc6716 PUBLIC '' 'http://xml.resource.org/public/rfc/bibxml/reference.RFC.6716.xml'>
 <!ENTITY rfc6982 PUBLIC '' 'http://xml.resource.org/public/rfc/bibxml/reference.RFC.6982.xml'>
 <!ENTITY rfc7587 PUBLIC '' 'http://xml.resource.org/public/rfc/bibxml/reference.RFC.7587.xml'>
 ]>
 <?rfc toc="yes" symrefs="yes" ?>
 
@@ -135,19 +136,19 @@ The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD",
 <t>
 An Ogg Opus stream is organized as follows.
 </t>
 <t>
 There are two mandatory header packets.
 The first packet in the logical Ogg bitstream MUST contain the identification
  (ID) header, which uniquely identifies a stream as Opus audio.
 The format of this header is defined in <xref target="id_header"/>.
-It MUST be placed alone (without any other packet data) on the first page of
- the logical Ogg bitstream, and MUST complete on that page.
-This page MUST have its 'beginning of stream' flag set.
+It is placed alone (without any other packet data) on the first page of
+ the logical Ogg bitstream, and completes on that page.
+This page has its 'beginning of stream' flag set.
 </t>
 <t>
 The second packet in the logical Ogg bitstream MUST contain the comment header,
  which contains user-supplied metadata.
 The format of this header is defined in <xref target="comment_header"/>.
 It MAY span multiple pages, beginning on the second page of the logical
  stream.
 However many pages it spans, the comment header packet MUST finish the page on
@@ -182,31 +183,46 @@ The TOC sequence at the beginning of each Opus packet indicates the coding
  frames per packet, as described in Section&nbsp;3.1
  of&nbsp;<xref target="RFC6716"/>.
 The coding mode is one of SILK, Hybrid, or Constrained Energy Lapped Transform
  (CELT).
 The combination of coding mode, audio bandwidth, and frame size is referred to
  as the configuration of an Opus packet.
 </t>
 <t>
-The first audio data page SHOULD NOT have the 'continued packet' flag set
- (which would indicate the first audio data packet is continued from a previous
- page).
-Packets MUST be placed into Ogg pages in order until the end of stream.
-Audio packets MAY span page boundaries.
+Packets are placed into Ogg pages in order until the end of stream.
+Audio data packets might span page boundaries.
+The first audio data page could have the 'continued packet' flag set
+ (indicating the first audio data packet is continued from a previous page) if,
+ for example, it was a live stream joined mid-broadcast, with the headers
+ pasted on the front.
+A demuxer SHOULD NOT attempt to decode the data for the first packet on a page
+ with the 'continued packet' flag set if the previous page with packet data
+ does not end in a continued packet (i.e., did not end with a lacing value of
+ 255) or if the page sequence numbers are not consecutive, unless the demuxer
+ has some special knowledge that would allow it to interpret this data
+ despite the missing pieces.
 An implementation MUST treat a zero-octet audio data packet as if it were a
  malformed Opus packet as described in
  Section&nbsp;3.4 of&nbsp;<xref target="RFC6716"/>.
 </t>
 <t>
-The last page SHOULD have the 'end of stream' flag set, but implementations
- need to be prepared to deal with truncated streams that do not have a page
- marked 'end of stream'.
-The final packet on the last page SHOULD NOT be a continued packet, i.e., the
- final lacing value SHOULD be less than 255.
+A logical stream ends with a page with the 'end of stream' flag set, but
+ implementations need to be prepared to deal with truncated streams that do not
+ have a page marked 'end of stream'.
+There is no reason for the final packet on the last page to be a continued
+ packet, i.e., for the final lacing value to be less than 255.
+However, demuxers might encounter such streams, possibly as the result of a
+ transfer that did not complete or of corruption.
+A demuxer SHOULD NOT attempt to decode the data from a packet that continues
+ onto a subsequent page (i.e., when the page ends with a lacing value of 255)
+ if the next page with packet data does not have the 'continued packet' flag
+ set or does not exist, or if the page sequence numbers are not consecutive,
+ unless the demuxer has some special knowledge that would allow it to interpret
+ this data despite the missing pieces.
 There MUST NOT be any more pages in an Opus logical bitstream after a page
  marked 'end of stream'.
 </t>
 </section>
 
 <section anchor="granpos" title="Granule Position">
 <t>
 The granule position MUST be zero for the ID header page and the
@@ -219,18 +235,18 @@ The granule position of an audio data page encodes the total number of PCM
  samples in the stream up to and including the last fully-decodable sample from
  the last packet completed on that page.
 The granule position of the first audio data page will usually be larger than
  zero, as described in <xref target="start_granpos_restrictions"/>.
 </t>
 
 <t>
 A page that is entirely spanned by a single packet (that completes on a
- subsequent page) has no granule position, and the granule position field MUST
- be set to the special value '-1' in two's complement.
+ subsequent page) has no granule position, and the granule position field is
+ set to the special value '-1' in two's complement.
 </t>
 
 <t>
 The granule position of an audio data page is in units of PCM audio samples at
  a fixed rate of 48&nbsp;kHz (per channel; a stereo stream's granule position
  does not increment at twice the speed of a mono stream).
 It is possible to run an Opus decoder at other sampling rates, but the value
  in the granule position field always counts samples assuming a 48&nbsp;kHz
@@ -372,17 +388,18 @@ These samples need to be stored and decoded, as Opus is an asymptotically
  convergent predictive codec, meaning the decoded contents of each frame depend
  on the recent history of decoder inputs.
 However, a player will want to skip these samples after decoding them.
 </t>
 
 <t>
 A 'pre-skip' field in the ID header (see <xref target="id_header"/>) signals
  the number of samples that SHOULD be skipped (decoded but discarded) at the
- beginning of the stream.
+ beginning of the stream, though some specific applications might have a reason
+ for looking at that data.
 This amount need not be a multiple of 2.5&nbsp;ms, MAY be smaller than a single
  packet, or MAY span the contents of several packets.
 These samples are not valid audio.
 </t>
 
 <t>
 For example, if the first Opus frame uses the CELT mode, it will always
  produce 120 samples of windowed overlap-add data.
@@ -520,19 +537,19 @@ Both of these will be greater than '0' in this case.
 </t>
 </section>
 
 <section anchor="seeking_and_preroll" title="Seeking and Pre-roll">
 <t>
 Seeking in Ogg files is best performed using a bisection search for a page
  whose granule position corresponds to a PCM position at or before the seek
  target.
-With appropriately weighted bisection, accurate seeking can be performed with
- just three or four bisections even in multi-gigabyte files.
-See <xref target="seeking"/> for general implementation guidance.
+With appropriately weighted bisection, accurate seeking can be performed in
+ just one or two bisections on average, even in multi-gigabyte files.
+See <xref target="seeking"/> for an example of general implementation guidance.
 </t>
 
 <t>
 When seeking within an Ogg Opus stream, an implementation SHOULD start decoding
  (and discarding the output) at least 3840&nbsp;samples (80&nbsp;ms) prior to
  the seek target in order to ensure that the output audio is correct by the
  time it reaches the seek target.
 This 'pre-roll' is separate from, and unrelated to, the 'pre-skip' used at the
@@ -655,18 +672,18 @@ The original sample rate of the audio passed to the encoder is not preserved
 <vspace blankLines="1"/>
 An Ogg Opus player SHOULD select the playback sample rate according to the
  following procedure:
 <list style="numbers">
 <t>If the hardware supports 48&nbsp;kHz playback, decode at 48&nbsp;kHz.</t>
 <t>Otherwise, if the hardware's highest available sample rate is a supported
  rate, decode at this sample rate.</t>
 <t>Otherwise, if the hardware's highest available sample rate is less than
- 48&nbsp;kHz, decode at the next highest supported rate above this and
- resample.</t>
+ 48&nbsp;kHz, decode at the next higher Opus supported rate above the highest
+ available hardware rate and resample.</t>
 <t>Otherwise, decode at 48&nbsp;kHz and resample.</t>
 </list>
 However, the 'Input Sample Rate' field allows the muxer to pass the sample
  rate of the original input stream as metadata.
 This is useful when the user requires the output sample rate to match the
  input sample rate.
 For example, when not playing the output, an implementation writing PCM format
  samples to disk might choose to resample the audio back to the original input
@@ -1179,16 +1196,18 @@ Making this check before allocating the associated memory to contain the data
 
 <t>
 Immediately following the user comment list, the comment header MAY
  contain zero-padding or other binary data which is not specified here.
 If the least-significant bit of the first byte of this data is 1, then editors
  SHOULD preserve the contents of this data when updating the tags, but if this
  bit is 0, all such data MAY be treated as padding, and truncated or discarded
  as desired.
+This allows informal experimentation with the format of this binary data until
+ it can be specified later.
 </t>
 
 <t>
 The comment header can be arbitrarily large and might be spread over a large
  number of Ogg pages.
 Implementations MUST avoid attempting to allocate excessive amounts of memory
  when presented with a very large comment header.
 To accomplish this, implementations MAY reject a comment header larger than
@@ -1252,17 +1271,18 @@ If a player chooses to make use of the R128_TRACK_GAIN tag or the
 If a tool modifies the ID header's 'output gain' field, it MUST also update or
  remove the R128_TRACK_GAIN and R128_ALBUM_GAIN comment tags if present.
 A muxer SHOULD place the gain it wants other tools to use by default into the
  'output gain' field, and not the comment tag.
 </t>
 <t>
 To avoid confusion with multiple normalization schemes, an Opus comment header
  SHOULD NOT contain any of the REPLAYGAIN_TRACK_GAIN, REPLAYGAIN_TRACK_PEAK,
- REPLAYGAIN_ALBUM_GAIN, or REPLAYGAIN_ALBUM_PEAK tags.
+ REPLAYGAIN_ALBUM_GAIN, or REPLAYGAIN_ALBUM_PEAK tags, unless they are only
+ to be used in some context where there is guaranteed to be no such confusion.
 <xref target="EBU-R128"/> normalization is preferred to the earlier
  REPLAYGAIN schemes because of its clear definition and adoption by industry.
 Peak normalizations are difficult to calculate reliably for lossy codecs
  because of variation in excursion heights due to decoder differences.
 In the authors' investigations they were not applied consistently or broadly
  enough to merit inclusion here.
 </t>
 </section> <!-- end comment_format -->
@@ -1272,21 +1292,22 @@ In the authors' investigations they were not applied consistently or broadly
 
 <section anchor="packet_size_limits" title="Packet Size Limits">
 <t>
 Technically, valid Opus packets can be arbitrarily large due to the padding
  format, although the amount of non-padding data they can contain is bounded.
 These packets might be spread over a similarly enormous number of Ogg pages.
 When encoding, implementations SHOULD limit the use of padding in audio data
  packets to no more than is necessary to make a variable bitrate (VBR) stream
- constant bitrate (CBR).
+ constant bitrate (CBR), unless they have no reasonable way to determine what
+ is necessary.
 Demuxers SHOULD reject audio data packets (treat them as if they were malformed
  Opus packets with an invalid TOC sequence) larger than 61,440 octets per
- Opus stream.
-Such packets necessarily contain more padding than needed for this purpose.
+ Opus stream, unless they have a specific reason for allowing extra padding.
+Such packets necessarily contain more padding than needed to make a stream CBR.
 Demuxers MUST avoid attempting to allocate excessive amounts of memory when
  presented with a very large packet.
 Demuxers MAY reject or partially process audio data packets larger than
  61,440&nbsp;octets in an Ogg Opus stream with channel mapping families&nbsp;0
  or&nbsp;1.
 Demuxers MAY reject or partially process audio data packets in any Ogg Opus
  stream if the packet is larger than 61,440&nbsp;octets and also larger than
  7,680&nbsp;octets per Opus stream.
@@ -1339,20 +1360,21 @@ In encoders derived from the reference
 </t>
 <figure align="center">
 <artwork align="center"><![CDATA[
  opus_encoder_ctl(encoder_state, OPUS_GET_LOOKAHEAD(&delay_samples));
 ]]></artwork>
 </figure>
 <t>
 To achieve good quality in the very first samples of a stream, implementations
- MAY use linear predictive coding (LPC) extrapolation
- <xref target="linear-prediction"/> to generate at least 120 extra samples at
- the beginning to avoid the Opus encoder having to encode a discontinuous
- signal.
+ MAY use linear predictive coding (LPC) extrapolation to generate at least 120
+ extra samples at the beginning to avoid the Opus encoder having to encode a
+ discontinuous signal.
+For more information on linear prediction, see
+ <xref target="linear-prediction"/>.
 For an input file containing 'length' samples, the implementation SHOULD set
  the pre-skip header value to (delay_samples&nbsp;+&nbsp;extra_samples), encode
  at least (length&nbsp;+&nbsp;delay_samples&nbsp;+&nbsp;extra_samples)
  samples, and set the granule position of the last page to
  (length&nbsp;+&nbsp;delay_samples&nbsp;+&nbsp;extra_samples).
 This ensures that the encoded file has the same duration as the original, with
  no time offset. The best way to pad the end of the stream is to also use LPC
  extrapolation, but zero-padding is also acceptable.
@@ -1509,51 +1531,96 @@ In such cases the the '.opus' filename extension is NOT RECOMMENDED.
 
 <t>
 In either case, this document updates <xref target="RFC5334"/>
  to add 'opus' as a codecs parameter value with char[8]: 'OpusHead'
  as Codec Identifier.
 </t>
 </section>
 
-<section title="IANA Considerations">
+<section anchor="iana" title="IANA Considerations">
 <t>
 This document updates the IANA Media Types registry to add .opus
  as a file extension for "audio/ogg", and to add itself as a reference
  alongside <xref target="RFC5334"/> for "audio/ogg", "video/ogg", and
  "application/ogg" Media Types.
 </t>
+<t>
+This document defines a new registry "Opus Channel Mapping Families" to
+ indicate how the semantic meanings of the channels in a multi-channel Opus
+ stream are described.
+IANA SHALL create a new name space of "Opus Channel Mapping Families".
+All maintenance within and additions to the contents of this name space MUST be
+ according to the "Specification Requried with Expert Review" registration
+ policy as defined in <xref target="RFC5226"/>.
+Each registry entry consists of a Channel Mapping Family Number, which is
+ specified in decimal in the range 0 to 255, inclusive, and a Reference (or
+ list of references)
+Each Reference must point to sufficient documentation to describe what
+ information is coded in the Opus identification header for this channel
+ mapping family, how a demuxer determines the Stream Count ('N') and Coupled
+ Stream Count ('M') from this information, and how it determines the proper
+ interpretation of each of the decoded channels.
+</t>
+<t>
+This document defines three initial assignments for this registry.
+</t>
+<texttable>
+<ttcol>Value</ttcol><ttcol>Reference</ttcol>
+<c>0</c><c>[RFCXXXX] <xref target="channel_mapping_0"/></c>
+<c>1</c><c>[RFCXXXX] <xref target="channel_mapping_1"/></c>
+<c>255</c><c>[RFCXXXX] <xref target="channel_mapping_255"/></c>
+</texttable>
+<t>
+The designated expert will determine if the Reference points to a specification
+ that meets the requirements for permanence and ready availability laid out
+ in&nbsp;<xref target="RFC5226"/> and that it specifies the information
+ described above with sufficient clarity to allow interoperable
+ implementations.
+</t>
 </section>
 
 <section anchor="Acknowledgments" title="Acknowledgments">
 <t>
-Thanks to Mark Harris, Greg Maxwell, Christopher "Monty" Montgomery, and
- Jean-Marc Valin for their valuable contributions to this document.
+Thanks to Ben Campbell, Mark Harris, Greg Maxwell, Christopher "Monty"
+ Montgomery, Jean-Marc Valin, and Mo Zanaty for their valuable contributions to
+ this document.
 Additional thanks to Andrew D'Addesio, Greg Maxwell, and Vincent Penquerc'h for
  their feedback based on early implementations.
 </t>
 </section>
 
-<section title="Copying Conditions">
+<section title="RFC Editor Notes">
+<t>
+In&nbsp;<xref target="iana"/>, "RFCXXXX" is to be replaced with the RFC number
+ assigned to this draft.
+</t>
+<t>
+In the Copyright Notice at the start of the document, the following paragraph
+ is to be appended after the regular copyright notice text:
+</t>
 <t>
-The authors agree to grant third parties the irrevocable right to copy, use,
- and distribute the work, with or without modification, in any medium, without
- royalty, provided that, unless separate permission is granted, redistributed
- modified works do not contain misleading author, version, name of work, or
- endorsement information.
+"The licenses granted by the IETF Trust to this RFC under Section&nbsp;3.c of
+ the Trust Legal Provisions shall also include the right to extract text from
+ Sections&nbsp;1 through&nbsp;14 of this RFC and create derivative works from
+ these extracts, and to copy, publish, display, and distribute such derivative
+ works in any medium and for any purpose, provided that no such derivative work
+ shall be presented, displayed, or published in a manner that states or implies
+ that it is part of this RFC or any other IETF Document."
 </t>
 </section>
 
 </middle>
 <back>
  &rfc4732;
+ &rfc5226;
  &rfc5334;
  &rfc6381;
  &rfc6716;